define(['jquery', 'virtual-dom/h', 'render-tree', 'theme-ecmwf-2017/bootstrap/dropdown'], function($, h, RenderTree) {

	function AppMenu(options) {

		var el = options.el
		var items = options.items

		function item(menu, item) {
			return item.title
				? h('li' + (item.is_selected ? '.selected' : ''), [
					h('a' + (item.is_selected ? '.ui-icon.ui-icon-check' : ''), {
						href: (item.href || ('#' + item.name)),
						rel: 'external',
						onclick: item.href ? (typeof item.href === 'function' ? prevent(item.href) : undefined) : function(e) {
							item.selected ? item.selected() : Bus().send(['menu', menu.name, item.name, 'select'].join('-'));
							e.preventDefault();
						}
					}, [item.title])
				])
				: h('li.divider')
		}

		var a = new RenderTree({
			root: el,
			items: items,
			main: {
				render: function() {
					return h('.row', [
						h('.col-xs-9.col-sm-9', [
							h('ul#main-menu', $.map(items, function(menu){
								if(menu.enabled === false) return;
								return h('li' + (menu.classes ? $.map(menu.classes.split(' '), function(v){ return '.' + v }) : ''), {name: menu.name}, [
									h('.btn-group', [
										h( 'a.btn.btn-link.dropdown-toggle',
											(menu.items
												? {type: 'button', attributes: {'data-toggle': 'dropdown'}, onclick: menu.onclick}
												: {href: menu.href/*, onclick: function(){ console.log('click') }*/}),
											[menu.title, h('span' + (menu.items ? '.caret' : ''))]
										),
										h('ul.dropdown-menu.dropdown-menu-small.' + css_name(menu.title), typeof menu.items === 'function' ? menu.items() : $.map(menu.items, function(v) { return item(menu, v) }))
									])
								])
							}))
						]),
						h('.col-xs-3.col-sm-3.text-right-xs.text-right-sm.text-right-md.text-right-lg', [
							h('ul#help-menu', $.map(options.help, function(menu){
								return h('li', [
									h('.btn-group', [
										h('a.btn.btn-link.dropdown-toggle', {type: 'button', attributes: {'data-toggle': 'dropdown'}}, [menu.title, h('span.caret')]),
										h('ul.dropdown-menu.pull-right', $.map(menu.items, function(v) { return item(menu, v) }))
									])
								])
							}))
						])
					])
				}
			}
		})

		return a
	}

	function prevent(f) {
		return function(e) {
			f()
			e.preventDefault()
		}
	}

	function css_name(name){
		return name.replace(' ', '-').toLowerCase();
	}

	return AppMenu
})
