import extend from 'extend'
import h from 'virtual-dom/h'
import Settings from 'settings'
import Ajaxqueue from 'ajax_queue'
import Observable from 'observable'
import Parameters from 'chart/model/parameters'
import Tabs from 'dashboard/model'
import Product from 'chart/product'
import Chart from 'eccharts-2/chart'

function DashboardSet(options) {
	var self = this

	var o = this.options = extend({
		data: null
	}, options);

	this.charts = []

	var time = new Parameters.time()

	Token.then(function(token){
		var dashboard = o.data.dashboards[0]

		Tabs.get_dashboard(dashboard.name, function(result){
			extend(dashboard, result);
			var i = 0
			dashboard.columns.forEach(function(column) {
				column.forEach(function(item) {
					var j = i++;
					Tabs.Widget.get(item, function(widget) {
						if(widget.kind === 'chart'){
							self.charts.push(widget)

							var div = document.createElement('div')
							div.id = widget.name
							div.className = 'dashboard-widget'
							div.style.left = '20px'
							div.style.top =  90 + j * 180 + 'px'
							document.body.appendChild(div)

							var location = new Observable()
							location.set(Settings.get('last-probe-location', null))

							/*
    						var product = new Product()
							product.init({product: widget.data.product.name});
							product.get_chart({
								json: {
									product: product.as_json({width: 128, height: 64}, null, null, 'png')
								},
								success: function(r){
									console.log('->success', r)
								}
							})
							*/
							/*
							Ajaxqueue({
								url: '/plots/get-plot/',
								json: {
									product: widget.data.product.name
								},
								success: function(r){
									console.log('->success', r)
								}
							})
							*/

							new Chart({
								product: widget.data.product.name,
								target: widget.name,
								time: time,
								location: location,
								token: token
							})

							o.renderer.render()
						}
					})
				})
			})
		})
	})
}

DashboardSet.prototype = {
	render: function() {
		var i = 0
		return h('div', this.charts.map(function(widget){ return h('div', {style: {position: 'absolute', top: ( 90 + i++ * 180) + 'px'}}, widget.title) }));
	}
}

// TODO add token to user-info
var Token = new Promise(function(resolved) {
	Ajaxqueue({
		url: '/plots/get-token/',
		dataType: 'jsonp',
		complete: function(result) {
			if(result && result.token){
				resolved(result.token)
			}else{
				console.warn('failed to get token');
			}
		}
	});
})

export default DashboardSet;
