define(['jquery', 'bus', '../widgets/widget'], function($, Bus, DashboardWidget){

	function WidgetTestable(w, dt){
		this.w = w // TODO support creation of new widget in constructor here
		this.dt = dt
		this.test = dt.test
	}

	WidgetTestable.prototype = {
		add_help_panel: function(){
			var self = this;

			self.test.assert_no_element('.help-panel')

			return $.Deferred(function(df){
				var button = self.w.element.find('.ui-icon-help:first')
				var id = parent
				button.click();
				self.test.wait_for('.help-panel').then(function(){
					var panel = $('.help-panel')
					self.test.assert(panel.attr('name') === self.name(), 'id "' + panel.attr('name') + '" (expected ' + self.name() + ')')
					self.test.wait_find(panel, '.content.markup').then(function(content){
						panel.find('.close').click()
						self.test.wait_for_remove('.help-panel').then(function(){
							df.resolve()
						})
					})
				})
			})
		},

		name: function(){
			return this.w.options.name;
		},

		title: function(){
			return this.w.options.title;
		}
	}

	return WidgetTestable
});
