import extend from 'extend'
import mixins from 'mixins'

function ChartAnimator(args) {
	var o = this.options = extend({
		time: null,  // type Observable
	}, args);

	this.animating = false;
}

ChartAnimator.prototype = extend({
	start: function() {
		console.log('start')
		this.timer = setInterval(this.bind(this.step), 4000)
		this.animating = true
		this.step()
	},

	stop: function() {
		console.log('stop')
		this.timer = clearInterval(this.timer)
		this.animating = false
	},

	toggle: function() {
		console.log('toggle')
		this.animating ? this.stop() : this.start()
	},

	step: function() {
		console.log('step')
		this.options.time.next()
	}
}, mixins)

export default ChartAnimator
