import h from 'virtual-dom/h'
import Settings from 'settings'
import mixins from 'mixins'
import Meteogram from './meteogram'

function Multigrams(args) {
	var o = this.options = extend({
		location: null, // type Observable
	},
	Settings.get('meteograms-list', {products: ['10d_epsgram_2t']}),
	args);

	this.meteograms = []

	var location = o.location.value;

	o.products.forEach(this.bind(this.add_product))
}

Multigrams.prototype = extend({
	render: function() {
		return h('ul', this.meteograms.map(function(m) {
			return m.render()
		}))
	},

	add_product: function(p) {
		this.meteograms.push(new Meteogram({
			product: p,
			renderer: this.options.renderer
		}))
	}
}, mixins)

export default Multigrams
