import h from 'virtual-dom/h'
import Dialogue from 'dialogue'

function View (options) {
	var self = this;

	var o = this.options = extend({
		title: ''
	}, options);

	this.dialogue = new Dialogue({
		renderer: o.renderer,
		id: o.title.replace(' ', '-').toLowerCase(),
		title: o.title,
		className: 'view' + (!!~['Legends', 'Probe'].indexOf(o.title) ? '.no-header' : ''),
		draggable: true,
		position: {top: 100, left: 100},
		on_close: o.on_close
	})

	function ready(Content) {
		self.content = new Content.default({
			renderer: o.renderer
		});
		o.renderer.render()
	}

	switch(o.title){
		case 'Probe':
			require(['./views/probe'], ready)
			break;
		case 'Cities':
			require(['./views/cities'], ready)
			break;
		case 'Meteograms':
			require(['./views/meteograms'], ready)
			break;
		case 'Time series':
			require(['./views/time_series'], ready)
			break;
		case 'Info':
			require(['./views/info'], ready)
			break;
		case 'Legends':
			require(['./views/legends'], ready)
			break;
		case 'Vertical profiles':
			require(['./views/vertical_profiles'], ready)
			break;
	}
}

View.prototype = {
	render: function() {
		return this.dialogue.render(this.content.render())
	},

	content: {
		render: function() { return h('')}
	}
}

export default View
