import h from 'virtual-dom/h'
import Settings from 'settings'
import Bus from 'bus'
import Ajaxqueue from 'ajax_queue'

function px(obj) {
	var r = {}
	for(var i in obj){
		r[i] = !!~['width', 'height'].indexOf(i)
			? obj[i] + 'px'
			: obj[i]
	}
	return r;
}

function Legends(args) {
	var self = this;

	var o = this.options = extend({
	}, args)

	this.legends = []

	this.factor = Settings.get('legends_size', 1);

	this.size = {
		width: 350 * self.factor,
		height: 50 * self.factor
	}

	Bus()
		.listen('chart-content-update', function(event, msg) {
			self.product = msg.product
			self.legends.length = self.product.layerList().length
			o.renderer.render()
		})
}

Legends.prototype = {
	render: function() {
		var self = this

		if(!this.product) return h('div');
		var layers = this.product.layerList().reverse();

		return h('.body', layers.map(function(layer, i){
			if(!layer.has_data || !layer.visible) return;

			var src = self.legends[i]
			if(!src) self.fetch(layer, i) // TODO prevent fetch happening multiple times

			return h('li', [
				h('h4', layer.title),
				h('div', {style: px(self.size)}, [
					src ? h('img', {src: src || ''}) : undefined
				])
			])
		}))
	},

	fetch: function(layer, i) {
		var self = this

		Ajaxqueue({
			cancelled_by: this.product.owner,         // TODO
			url         : '/backend/layer-legend/',
			priority    : 'low',
//			status      : ECMWF.ajax_loader(self.tr[j]),
			cache       : 24 * 60 * 60,
			json        : {
				product: this.product.as_json(this.size, null),
				layer: layer.id,
				size: self.size
			},
			success     : function(result) {
				self.legends[i] = result.url
				self.options.renderer.render()
			}
		})
	}
}

export default Legends
