define([], function() {

function hasOwn(class2type) {
	return class2type.hasOwnProperty;
}

function isPlainObject(obj) {
	var key;

	if(typeof obj !== 'object' || obj.nodeType || obj === obj.window){
		return false;
	}

	if(obj.constructor &&
			!hasOwn.call(obj, 'constructor') &&
			!hasOwn.call(obj.constructor.prototype || {}, 'isPrototypeOf')){
		return false;
	}

	/*jsl:ignore*/
	for (key in obj) {}
	/*jsl:end*/

	return key === undefined || hasOwn.call(obj, key);
}

function extend() {
	var options, name, src, copy, copyIsArray, clone,
		target = arguments[ 0 ] || {},
		i = 1,
		length = arguments.length,
		deep = false;

	if (typeof target === 'boolean') {
		deep = target;

		target = arguments[i] || {};
		i++;
	}

	if (typeof target !== "object" && !jQuery.isFunction(target)) {
		target = {};
	}

	for(;i < length;i++) {

		if((options = arguments[i]) !== null){

			for(name in options){
				src = target[name];
				copy = options[name];

				if(target === copy){
					continue;
				}

				if(deep && copy && (isPlainObject(copy) || (copyIsArray = Array.isArray(copy)))){

					if(copyIsArray){
						copyIsArray = false;
						clone = src && Array.isArray(src) ? src : [];

					} else {
						clone = src && isPlainObject(src) ? src : {};
					}

					target[name] = extend(deep, clone, copy);

				} else if(copy !== undefined){
					target[ name ] = copy;
				}
			}
		}
	}

	return target;
}

return extend

})
