
import h from 'virtual-dom/h'
import Grid from 'grid'
import Settings from 'settings'
import Bus from 'bus'
import './thumbnail_list.css'

function ThumbnailList(options) {
	var self = this

	var o = this.options = extend({
		onclick: function(){}
	}, options);

	this.active = true

	o.renderer.on.render.once(function(){
		self.grid = new Grid({
			renderer: o.renderer,
			products: o.products,
			view_mode: 'horizontal',
			width: 840,
			height: 170,
			on_click: function(selection){
				console.log('ThumbnailList: click. selection=', selection);
				Bus().send(o.products.kind + '-thumbnail-click', { name: selection.name(), use_product_projection: (Settings.get('use_product_projection') === 'use_product_projection') });
				o.onclick(selection)
			}
		})

		o.products.set_list()
	})

	o.renderer.render()
}

ThumbnailList.prototype = {
	render: function() {
		return h('.' + this.options.products.kind + 's', {style: {display: this.active ? 'block' : 'none'}}, [
			this.grid ? this.grid.render() : h('div', 'not ready')
		])
	}
}

export default ThumbnailList;
