import $ from 'jquery'
import Form from 'form'
import 'select-image'

function ThumbnailHandler() {

	this.render = function (item) {
		var checked  = {};
		var defaults = item.get_defaults();

		$.each(defaults, function(_,def) { checked[def] = true; });

		var div = $('<div>').addClass('form-thumbnail-item-wrapper');
		var img = $('<img>').appendTo(div);
		$('<br>').appendTo(div);

		var urls = {};

		var select = $('<select>').addClass('form-thumbnail-item').appendTo(div);
		$.each(item.get_values(), function(i, value) {
			var label = item.get_label(value);
			var opt = $('<option>', {
				value : value,
				text  : label.title,
				title : label.url
			}).appendTo(select);

			if(checked[value]) {
				opt.prop('selected', 'selected');
				img.attr('src', label.url);
				if(label.fetch_image) {
					label.fetch_image(img, function(url) {
						urls[value] = label.url = url;
					})
				}
			}

			urls[value] = label.url;
		});

		select.change(function() {
			img.attr('src', urls[select.val()]);
		})

		select.selectImage(item._item);

		return div;
	}

	this.collect = function (item, widget) {
		var l = [];
		// TODO: change to widget.val();
		$.each(widget.find(":checked"),  function () { l.push(this.value); });
		$.each(widget.find(":selected"), function () { l.push(this.value); });
		return item.multiple() ? l : l[0];
	};
}

$.addFormHandler('thumbnail', ThumbnailHandler);
