/*
 *   Eccharts meteogram panel
 */
define(['jquery', 'bus', 'log', 'settings', 'multigrams', 'probe'], function($, Bus, Log, Settings) {
	Log = Log.default

	var count = 0;

	$.widget('ui.meteograms', {

		options: {
			show_load: true,
			height : 120,
			width  : 525
		},

		_init: function(){
			var self = this, o = this.options;

			o.messageBus = self.element.messageBus()

			o.messageBus.listen('multigrams-list-changed', function (_, msg) {
				Settings.set('meteograms-list', msg);
				Log.message('Meteogram List updated');
			})

			if(!o.products) {
				o.products = ['10d_epsgram_2t', '10d_epsgram_tp'];
			}

			if(o.family === 'vertical_all') o.show_load = o.show_more = false;

			self.name = 'meteograms_' + (++count);

			self.element
				.addClass('meteograms')
				.on('show', function() {
					$.openProbe(self);
					self.element.find('.meteogram').meteogram('active')
				})
				.on('hide', function() {
					$.closeProbe(self);
					self.element.find('.meteogram').meteogram('active', false)
				})
				.multigrams(o);
		},

		_destroy: function(){
			this.element
				.removeClass('meteograms')
				.multigrams('destroy')
				.empty();
			return this;
		}
	})
});
